//
//  TagSection.swift
//  
//
//  Created by Loris Perret on 05/12/2023.
//

import Foundation

class TagSection {
    let name: String // OnBoarding
    var definitions = [TagDefinition]()
    
    init(name: String) {
        self.name = name
    }
    
    static func match(_ line: String) -> TagSection? {
        guard line.range(of: "\\[\\[(.*?)]]$", options: .regularExpression, range: nil, locale: nil) != nil else {
            return nil
        }
        
        let sectionName = line
            .replacingOccurrences(of: ["[", "]"], with: "")
            .removeLeadingTrailingWhitespace()
        return TagSection(name: sectionName)
    }
    
    func hasOneOrMoreMatchingTags(tags: [String]) -> Bool {
        let allTags = definitions.flatMap { $0.tags }
        let allTagsSet = Set(allTags)
        
        let intersection = Set(tags).intersection(allTagsSet)
        if intersection.isEmpty {
            return false
        }
        return true
    }
}
